> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For full documentation content, see https://docs.nvidia.com/infra-controller/llms-full.txt.

# Update IP Block

PATCH https://carbide-rest-api.carbide.svc.cluster.local/v2/org/{org}/carbide/ipblock/{ipBlockId}
Content-Type: application/json

Update an existing IP Block

Org must have an Infrastructure Provider. Specified IP Block must have been created by the Provider and requesting user must have `FORGE_PROVIDER_ADMIN` role. Only root IP Blocks can be patched.

Tenant IP Blocks are managed via Allocation.

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/ip-block/update-ipblock

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NCX Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/carbide/ipblock/{ipBlockId}:
    patch:
      operationId: update-ipblock
      summary: Update IP Block
      description: >-
        Update an existing IP Block


        Org must have an Infrastructure Provider. Specified IP Block must have
        been created by the Provider and requesting user must have
        `FORGE_PROVIDER_ADMIN` role. Only root IP Blocks can be patched.


        Tenant IP Blocks are managed via Allocation.
      tags:
        - subpackage_ipBlock
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: ipBlockId
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/IpBlock'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/IpBlockUpdateRequest'
servers:
  - url: https://carbide-rest-api.carbide.svc.cluster.local
components:
  schemas:
    IpBlockUpdateRequest:
      type: object
      properties:
        name:
          type: string
        description:
          type: string
      description: Request data for editing IP block
      title: IpBlockUpdateRequest
    IpBlockRoutingType:
      type: string
      enum:
        - Public
        - DatacenterOnly
      title: IpBlockRoutingType
    IpBlockProtocolVersion:
      type: string
      enum:
        - IPv4
        - IPv6
      title: IpBlockProtocolVersion
    IpBlockUsageStats:
      type: object
      properties:
        availableIPs:
          type: integer
          format: int64
          description: Number of IP addresses available in the block
        acquiredIPs:
          type: integer
          format: int64
          description: Number of individual IP addresses acquired from the block
        availablePrefixes:
          type: array
          items:
            type: string
          description: Example prefixes available to acquire
        availableSmallestPrefixes:
          type: integer
          format: int64
          description: Number of smallest prefixes available to acquire
        acquiredPrefixes:
          type: integer
          format: int64
          description: Number of prefixes acquired from this block
      description: Usa statistics for an IP Block
      title: IpBlockUsageStats
    IpBlockStatus:
      type: string
      enum:
        - Pending
        - Provisioning
        - Ready
        - Deleting
        - Error
      description: Status values for IP Block objects
      title: IpBlockStatus
    StatusDetail:
      type: object
      properties:
        status:
          type: string
        message:
          type: string
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Describes the details of a status transition for a resource
      title: StatusDetail
    Deprecation:
      type: object
      properties:
        attribute:
          type:
            - string
            - 'null'
        queryParam:
          type:
            - string
            - 'null'
        endpoint:
          type:
            - string
            - 'null'
        replacedBy:
          type:
            - string
            - 'null'
        takeActionBy:
          type: string
          format: date-time
        notice:
          type: string
      description: Details of a particular deprecation in NCX Infra Controller API
      title: Deprecation
    IpBlock:
      type: object
      properties:
        id:
          type: string
          format: uuid
        name:
          type: string
        description:
          type: string
        siteId:
          type: string
          format: uuid
        infrastructureProviderId:
          type: string
          format: uuid
        tenantId:
          type:
            - string
            - 'null'
          format: uuid
        routingType:
          $ref: '#/components/schemas/IpBlockRoutingType'
        prefix:
          type: string
          description: Either IPv4 or IPv6 address
        prefixLength:
          type: integer
          description: 'Min: 1, Max: 32 for ipv4, 128 for ipv6'
        protocolVersion:
          $ref: '#/components/schemas/IpBlockProtocolVersion'
        usageStats:
          $ref: '#/components/schemas/IpBlockUsageStats'
        status:
          $ref: '#/components/schemas/IpBlockStatus'
        statusHistory:
          type: array
          items:
            $ref: '#/components/schemas/StatusDetail'
        deprecations:
          type: array
          items:
            $ref: '#/components/schemas/Deprecation'
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: >-
        IP block contains information about an IPv4 address pool owned by the
        Infrastructure Provider and assigned as an overlay network for a
        particular Site. It is equivalent to Network Resource in product
        terminology.
      title: IpBlock
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

        ```

```

## SDK Code Examples

```python example-1
import requests

url = "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock/ipBlockId"

payload = {
    "name": "Public Network Overlay for Site SJC-4",
    "description": "This is the primary IP overlay for SJC-4. All IPs are publicly routable"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript example-1
const url = 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock/ipBlockId';
const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"name":"Public Network Overlay for Site SJC-4","description":"This is the primary IP overlay for SJC-4. All IPs are publicly routable"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go example-1
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock/ipBlockId"

	payload := strings.NewReader("{\n  \"name\": \"Public Network Overlay for Site SJC-4\",\n  \"description\": \"This is the primary IP overlay for SJC-4. All IPs are publicly routable\"\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby example-1
require 'uri'
require 'net/http'

url = URI("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock/ipBlockId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Public Network Overlay for Site SJC-4\",\n  \"description\": \"This is the primary IP overlay for SJC-4. All IPs are publicly routable\"\n}"

response = http.request(request)
puts response.read_body
```

```java example-1
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock/ipBlockId")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Public Network Overlay for Site SJC-4\",\n  \"description\": \"This is the primary IP overlay for SJC-4. All IPs are publicly routable\"\n}")
  .asString();
```

```php example-1
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock/ipBlockId', [
  'body' => '{
  "name": "Public Network Overlay for Site SJC-4",
  "description": "This is the primary IP overlay for SJC-4. All IPs are publicly routable"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp example-1
using RestSharp;

var client = new RestClient("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock/ipBlockId");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"Public Network Overlay for Site SJC-4\",\n  \"description\": \"This is the primary IP overlay for SJC-4. All IPs are publicly routable\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift example-1
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "Public Network Overlay for Site SJC-4",
  "description": "This is the primary IP overlay for SJC-4. All IPs are publicly routable"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/ipblock/ipBlockId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```